SDL_GetPrefPath(3)

NAME
SDL_GetPrefPath - Get the user-and-app-specific path where files can be written.

HEADER FILE
Defined in SDL3/SDL_filesystem.h

SYNOPSIS
#include "SDL3/SDL.h"

char * SDL_GetPrefPath(const char *org, const char *app);

DESCRIPTION
Get the "pref dir". This is meant to be where users can write personal files (preferences and save games, etc) that are specific to your application. This directory is unique per user, per application.

This function will decide the appropriate location in the native filesystem, create the directory if necessary, and return a string of the absolute path to the directory in UTF-8 encoding.

On Windows, the string might look like: C:\Users\bob\AppData\Roaming\MyCompany\MyProgramName\ On Linux, the string might look like: /home/bob/.local/share/MyProgramName/ On macOS, the string might look like: /Users/bob/Library/ApplicationSupport/MyProgramName/ You should assume the path returned by this function is the only safe place to write files (and that SDL_GetBasePath (), while it might be writable, or even the parent of the returned path, isn't where you should be writing things).

Both the org and app strings may become part of a directory name, so please follow these rules:

• Try to use the same org string (_including case-sensitivity_) for all
  your applications that use this function.

• Always use a unique app string for each one, and make sure it never
  changes for an app once you've decided on it.

• Unicode characters are legal, as long as they are UTF-8 encoded, but...

• ...only use letters, numbers, and spaces. Avoid punctuation like "Game
  Name 2: Bad Guy's Revenge!" ... "Game Name 2" is sufficient.

The returned path is guaranteed to end with a path separator ('\' on Windows, '/' on most other platforms).

FUNCTION PARAMETERS

org the name of your organization.

app the name of your application.

RETURN VALUE
Returns a UTF-8 string of the user directory in platform-dependent notation. NULL if there's a problem (creating directory failed, etc.). This should be freed with SDL_free () when it is no longer needed.

AVAILABILITY
This function is available since SDL 3.2.0.

SEE ALSO
•(3), SDL_GetBasePath(3)